import { EditorPlugin } from '@draft-js-plugins/editor';
import { Store } from '@draft-js-plugins/utils';
import { EditorState } from 'draft-js';
import { ComponentType } from 'react';
import { AlignmentPluginsPubParams } from './TextAlignmentComponent';
import type { TextAlignmentPluginTheme } from './theme';
export interface AlignmentPluginConfig {
    theme?: TextAlignmentPluginTheme;
}
export declare type TextAlignmentPlugin = EditorPlugin & {
    TextAlignment: ComponentType<AlignmentPluginsPubParams>;
};
interface StoreItemMap {
    getEditorState?(): EditorState;
    setEditorState?(editorState: EditorState): void;
}
export declare type AlignmentPluginStore = Store<StoreItemMap>;
declare const _default: (config?: AlignmentPluginConfig) => TextAlignmentPlugin;
export default _default;
